      program ping
      include 'mpif.h'

      integer numtasks, rank, dest, source, count, tag, ierr, n
      integer sendtag, recvtag
      integer stat(MPI_STATUS_SIZE)
      integer sendmsg, recvmsg

      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, numtasks, ierr)

      dest = mod(rank+1,numtasks)
      source = mod(rank-1+numtasks,numtasks)
      sendtag = rank
      recvtag = source
      sendmsg = rank+10

!      write(*,*) 'dest=',dest,'  source=',source,' sendtag=',
!     &           sendtag,'  recvtag=',recvtag

      call MPI_SENDRECV(sendmsg, 1, MPI_INTEGER, dest, sendtag,
     &                  recvmsg, 1, MPI_INTEGER, source, recvtag, 
     &                  MPI_COMM_WORLD, stat, ierr)
   
      call MPI_GET_COUNT(stat, MPI_INTEGER, count, ierr)
      print *, 'Task ',rank,': Received', count, ' int(s) from task',
     &         stat(MPI_SOURCE), ' with tag ',stat(MPI_TAG),
     &         '  msg=',recvmsg
   
      call MPI_FINALIZE(ierr)

      end

